<?php

/**
* 05/10/2016
* @author Fabio Pereira
*/

namespace Inflightor\Util;

use Inflightor\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response;

class MessagesProcedureInflightor extends TeknisaCrud
{

    protected $entityManager;
	protected $crudService;
	
	const FILE_FORMAT = '.txt';
	
	const LENGTH_CODE_MSG 		= 12;
	const SQL_LISTAERROS        = "SELECT DSERRO, MIN(NRORDEM) AS NRORDEM FROM LISTAERROS WHERE CDFILIAL = :CDFILIAL AND NRLISTA = :NRLISTA GROUP BY DSERRO ORDER BY NRORDEM";
	const SQL_DELETE_LISTAERROS =  "DELETE FROM LISTAERROS WHERE CDFILIAL = :CDFILIAL AND NRLISTA = :NRLISTA";

	const SEPARATORKEY = "__";

	const MESSAGESBYCODE = array(
		"APP-00001" => "Falta ciclo para esta data para a companhia __0__. Verifique a opção Frequência de Ciclo para esta companhia.",
		"APP-00002" => "O vôo __0__ possui serviço(s) para a classe e esta não possui agrupamento de delivery cadastrado na opção 'Configuração de Passageiros'.  Verifique se este vôo seu prefixo ou equipamento possuem configuração de passageiros cadastradas corretamente.",
		"APP-00003" => "O item de faturamento __0__ da classe: __1__ e ciclo: __2__ do vôo pertence a classe mas a quantidade de passageiros desta classe não foi informada. Verifique a previsão de passageiros informada para esta classe e tente novamente.",
		"APP-00004" => "O item de faturamento __0__ da classe: __1__ e ciclo: __2__ do vôo possui proporção do tipo fixa, mas o valor da proporção não se encontra cadastrado. Verifique o item de faturamento na tabela de preços e tente novamente.",
		"APP-00005" => "O item de faturamento __0__ da classe: __1__ e ciclo: __2__ do vôo possui proporção do tipo variável, mas não há valor cadastrado na tabela para a quantidade de passageiros (__3__). Verifique o item de faturamento na tabela de preços e tente novamente.",
		"APP-00006" => "O item de faturamento __0__ da classe: __1__ e ciclo: __2__ do vôo possui proporção do tipo loading, mas o valor percentual do loading não se encontra cadastrado. Verifique o item de faturamento na tabela de preços e tente novamente.",
		"APP-00007" => "O item de faturamento __0__ da classe: __1__ e ciclo: __2__ do vôo possui proporção do tipo quantidade fixa, mas o valor desta não se encontra cadastrado ou possui valor zero. Verifique o item de faturamento no voo ou o mesmo na tabela de preços e tente novamente.",
		"APP-00008" => "Item de faturamento __0__ da classe: __1__ e ciclo: __2__ do voo __3__ não possui preço cadastrado para esta data ou possui preço zero. Verifique se existe tabela de preço cadastrada para este serviço e se esta tabela se encontra vigente nesta data.",
		"APP-00009" => "Existe mais de uma tabela de preços ativa no momento para a companhia __0__. Verifique a validade das tabelas de preço existentes e tente novamente.",
		"APP-00010" => "Item de faturamento __0__ da classe: __1__ e ciclo: __2__ do voo __3__ possui dois preços vigentes para o dia. Verifique a vigência do item de faturamento na tabela de preço e tente novamente.",
		"APP-00011" => "O item de faturamento __0__ da classe: __1__ e ciclo: __2__ possui mais de um intervalo cadastrado para a quantidade do item (__3__) na tabela de preço proporcional. Verifique a tabela de preço proporcional e tente novamente.",
		"APP-00012" => "O item de faturamento __0__ da classe: __1__ e ciclo: __2__ possui preço proporcional, mas não possui preço cadastrado para quantidade do item (__3__). Verifique a tabela de preço proporcional e tente novamente.",
		"APP-00013" => "O item de faturamento nacional __0__ da classe: __1__ e ciclo: __2__ possui preço cadastrado apenas em dólar e näo há índce financeiro cadastrado para a data para fazer a conversão para Moeda Corrente. Verifique o cadastro de índice financeiro ou a tabela de preços e tente novamente.",
		"APP-00014" => "O item de faturamento internacional __0__ da classe: __1__ e ciclo: __2__ possui preço cadastrado apenas na Moeda Corrente e näo há índce financeiro cadastrado para a data para fazer a conversão para dólar. Verifique o cadastro de índice financeiro ou a tabela de preços e tente novamente.",
		"APP-00015" => "Manuteção não permitida. O vôo já está cancelado.",
		"APP-00016" => "Não existe histórico para a companhia/vôo/trecho informados!",
		"APP-00017" => "Não existe configuração máxima de passageiros para o vôo __0__, nem para seu prefixo e equipamento! Favor verificar em 'Configuração de Passageiros' e tentar novamente.",
		"APP-00018" => "Período bloqueado. Operação não permitida.",
		"APP-00019" => "Operação Bloqueada. O item de faturamento __0__ da classe: __1__ e ciclo: __2__ possui preço proporcional e não está configurado como 1 por Pax.",
		"APP-00020" => "Voo ou trecho informado não encontrado.",
		"APP-00021" => "Não há dados para geração do retrobill para o período informado.",
		"APP-00022" => "Retrobill informado não encontrado.",
		"APP-00023" => "Operação bloqueada. Retrobill informado já foi aprovado ou faturado.",
		"APP-00024" => "Operação bloqueada. Plano de voo já gerado para retrobill informado.",
		"APP-00025" => "Operação bloqueada. Não há valor a ser cobrado no retrobill.",
		"APP-00026" => "Operação bloqueada. Retrobill informado não está aprovado.",
		"APP-00027" => "Voo retrobill não parametrizado para a companhia.",
		"APP-00028" => "Não há trecho ativo para o voo retrobill.",
		"APP-00029" => "Agrupamento de delivery não encontrado para classe __0__ nas configurações do voo __1__ ou do equipamento __2__ ou do prefixo __3__.",
		"APP-00030" => "Operação bloqueada. Valor absoluto não deve ser maior que o total do retrobill.",
		"APP-00031" => "Operação bloqueada. Valor percentual não deve ser maior que 100%.",
		"APP-00032" => "Agrupamento de delivery do retrobill não parametrizado para a companhia.",
		"APP-00033" => "Tipo de apuração informado é inválido.",
		"APP-00034" => "Índice financeiro não cadastrado para a companhia.",
		"APP-00035" => "Produto para taxa de aeroporto nacional deve ser informado.",
		"APP-00036" => "Produto para taxa de aeroporto internacional deve ser informado.",
		"APP-00037" => "Companhia de código __0__ não existe.",
		"APP-00038" => "Regeração do plano de vôo não permitida. Existem deliveries já emitidos para este vôo.",
		"APP-00039" => "Serviço genérico __0__ não cadastrado para filial e companhia de destino.",
		"APP-00040" => "Classe __0__ ou ciclo __1__ não cadastrado para o serviço __2__ na filial e companhia de destino.",
		"APP-00041" => "Serviço genérico __0__ cadastrado mais de uma vez para filial e companhia de destino.",
		"APP-00042" => "Operação bloqueada. Não há menu grid vigente para a companhia em __0__.",
		"APP-00043" => "Operação bloqueada. Não há tabela de preços vigente para a companhia __0__ em __1__.",
		"APP-00044" => "Operação bloqueada. Serviço __0__ da classe __1__ e ciclo __2__ não possui vínculo com o menu grid ativo da companhia.",
		"APP-00045" => "Ciclo __0__ não cadastrado para o serviço __1__ classe __2__.",
		"APP-00046" => "Operação bloqueada. Manual de destino já está em proposta ou reprovado.",
		"APP-00047" => "Operação bloqueada. Este equipamento não possui configuração de handling / miscelânea.",
		"APP-00048" => "Operação bloqueada. Existem notas fiscais emitidas para os serviços relacionados.",
		"APP-00049" => "Operação bloqueada. Existem deliveries emitidas para os serviços relacionados. ",
		"APP-00050" => "Operação bloqueada. Existem deliveries canceladas para o plano de voo.",
		"APP-00051" => "Não há Produto para taxa de aeroporto cadastrado no agrupamento informado.",
		"APP-00052" => "Previsão da companhia __0__ na data __1__ já aprovada",
		"APP-00053" => "Previsão da data __0__ já aprovada",
		"APP-00054" => "Previsão do voo __0__ na data __1__ já aprovada",
		"APP-00055" => "Operação bloqueada. Não há malha aérea configurada para a filial.",
		"APP-00056" => "Operação bloqueada. Existe previsão aprovada ou com checklist gerado para o voo __0__ na data __1__.",
		"APP-00057" => "Operação bloqueada. Existe mais de uma configuração na malha aérea para o voo __0__ na data __1__.",
		"APP-00058" => "Operação bloqueada. Número de previsão informado inválido.",
		"APP-00059" => "Não há dados para previsão do período informado",
		"APP-00060" => "Item de faturamento __0__ da classe: __1__ e ciclo: __2__ do voo __3__ não está vinculado a um menu grid vigente e aprovado.",
		"APP-00061" => "Operação bloqueada. O item de faturamento __0__ da classe: __1__ e ciclo: __2__ do vôo está vinculado a dois ou mais menu grids vigentes e aprovados.",
		"APP-00062" => "Operação bloqueada. O item de faturamento __0__ da classe: __1__ e ciclo: __2__ do vôo está vinculado a mais de um serviço do menu grid.",
		"APP-00063" => "Operação bloqueada. O item de faturamento __0__ da classe: __1__ e ciclo: __2__ do vôo não está vinculado a um subgrupo vigente do menu grid.",
		"APP-00064" => "Operação bloqueada. Já existe tabela de preço cadastrada para este período.",
		"APP-00065" => "Item de faturamento __0__ da classe: __1__ e ciclo: __2__",
		"APP-00066" => "Operação bloqueada. Menu grid vigente difere do menu grid indicado na tabela de preços.",
		"APP-00067" => "Operação bloqueada. Item de faturamento __0__ da classe __1__ e ciclo __2__ está vinculado a subgrupos com loading diferentes entre si e não está indicado como 1 por pax.",
		"APP-00068" => "Operação bloqueada. Item de faturamento __0__ da classe __1__ e ciclo __2__ possui loading diferente do cadastrado no subgrupo vinculado.",
		"APP-00069" => "Item de faturamento __0__ da classe __1__ e ciclo __2__ vinculado a mais de um menu grid",
		"APP-00070" => "Item de faturamento __0__ da classe __1__ e ciclo __2__ não vinculado aos menu grids informados",
		"APP-00071" => "Item de faturamento __0__ da classe __1__ e ciclo __2__ vinculado a dois ou mais serviços de menu grid __3__",
		"APP-00072" => "Item de faturamento __0__ da classe __1__ e ciclo __2__ não vinculado a subgrupos do menu grid __3__",
		"APP-00073" => "Serviço __0__ da classe: __1__ e ciclo: __2__",
		"APP-00074" => "  A receita é utilizada na composição do Menu Grid: '__0__' pertencente à Companhia '__1__' da Unidade '__2__'",
		"APP-00075" => "  A subreceita é utilizada na composição da Receita:  '__0__' vinculada com o Menu Grid: '__1__' pertencente à Companhia '__2__' da Unidade '__3__'",
		"APP-00076" => "Item de faturamento __0__ da classe: __1__ e ciclo: __2__ do voo __3__ está vinculado ao menu grid __4__ mas esta relação não está indicada na tabela de preços.",
		"APP-00077" => "Item de faturamento __0__ da classe: __1__ e ciclo: __2__ do voo __3__ está vinculado ao menu grid __4__ mas o mesmo não se encontra aprovado.",
		"APP-00078" => "Item de faturamento __0__ da classe: __1__ e ciclo: __2__ do voo __3__ está vinculado ao menu grid __4__ mas o mesmo não se encontra vigente.",
		"APP-00079" => "Item de faturamento __0__ da classe: __1__ e ciclo: __2__ do voo __3__ não está vinculado a um subgrupo vigente do menu grid __4__.",
		"APP-00080" => "Operação bloqueada. O item de faturamento __0__ da classe: __1__ e ciclo: __2__ do vôo está vinculado a mais de um item do menu grid __3__.",
		"APP-00081" => "Item de faturamento __0__ da classe: __1__ e ciclo: __2__ do voo __3__ está vinculado a subgrupos do menu grid __4__ mas nenhum está vigente.",
		"APP-00082" => "Operação bloqueada. O item de faturamento __0__ já está cadastrado no menu grid de destino e o mesmo se encontra aprovado.",
		"APP-00083" => "Operação bloqueada. Já existe plano de voo gerado para o voo __0__ na data __1__.",
		"APP-00084" => "Operação bloqueada. O item de faturamento __0__ da classe __1__ e ciclo __2__ não possui tipo de loading informado na tabela de preço.",
		"APP-00085" => "Operação bloqueada. O item de faturamento __0__ da classe __1__ e ciclo __2__ está vinculado a mais de um subgrupo com loading do tipo proporção fixa, com configurações de quantidade iguais entre si, e não está indicado como proporção fixa.",
		"APP-00086" => "Operação bloqueada. O item de faturamento __0__ da classe __1__ e ciclo __2__ está vinculado a mais de um subgrupo com loading do tipo proporção fixa, com configurações de quantidade diferentes entre si, e não está indicado como 1 por pax.",
		"APP-00087" => "Operação bloqueada. O item de faturamento __0__ da classe __1__ e ciclo __2__ está vinculado a mais de um subgrupo com loading do tipo tabela e não está indicado como 1 por pax.",
		"APP-00088" => "Operação bloqueada. O item de faturamento __0__ da classe __1__ e ciclo __2__ está vinculado a mais de um subgrupo com loading do tipo percentual e não está indicado como 1 por pax.",
		"APP-00089" => "Operação bloqueada. O item de faturamento __0__ da classe __1__ e ciclo __2__ está vinculado a mais de um subgrupo com loading do tipo quantidade fixa e não está indicado como quantidade fixa.",
		"APP-00090" => "Operação bloqueada. O item de faturamento __0__ da classe __1__ e ciclo __2__ está vinculado a subgrupos vigentes cujo loading se encontra vazio.",
		"APP-00091" => "Operação bloqueada. Subgrupo não possui data de vigência informada ou a vigência é inválida",
		"APP-00092" => "Receita __0__ - __1__ está inativa",
		"APP-00093" => "Receita __0__ - __1__ está inativa e está em uso no ciclo __2__ do subgrupo __3__ do serviço __4__ da classe __5__ do menu grid __6__ - __7__ da companhia __8__ na data __9__",
		"APP-00094" => "Receita __0__ - __1__ não possui variação para a unidade",
		"APP-00095" => "Receita __0__ - __1__ não possui variação para a unidade e está em uso no ciclo __2__ do subgrupo __3__ do serviço __4__ da classe __5__ do menu grid __6__ - __7__ da companhia __8__ na data __9__",
		"APP-00096" => "Receita __0__ - __1__ não possui rendimento informado na variação dessa unidade",
		"APP-00097" => "Receita __0__ - __1__ não possui rendimento informado na variação dessa unidade e está em uso no ciclo __2__ do subgrupo __3__ do serviço __4__ da classe __5__ do menu grid __6__ - __7__ da companhia __8__ na data __9__",
		"APP-00098" => "Receita flex __0__ - __1__ não possui número de opções definido na variação dessa unidade",
		"APP-00099" => "Receita flex __0__ - __1__ não possui número de opções definido na variação dessa unidade e está em uso no ciclo __2__ do subgrupo __3__ do serviço __4__ da classe __5__ do menu grid __6__ - __7__ da companhia __8__ na data __9__",
		"APP-00100" => "Produto __0__ - __1__ está inativo e é utilizado na receita __2__ - __3__ na variação dessa unidade",
		"APP-00101" => "Produto __0__ - __1__ está inativo e é utilizado na receita __2__ - __3__ na variação dessa unidade e está em uso no ciclo  __4__ do subgrupo __5__ do serviço __6__ da classe __7__ do menu grid __8__ - __9__ da companhia __10__ na data __11__",
		"APP-00102" => "Produto __0__ - __1__ está sem quantidade na receita __2__ - __3__ na variação dessa unidade",
		"APP-00103" => "Produto __0__ - __1__ está sem quantidade na receita __2__ - __3__ na variação dessa unidade e está em uso no ciclo  __4__ do subgrupo __5__ do serviço __6__ da classe __7__ do menu grid __8__ - __9__ da companhia __10__ na data __11__",
		"APP-00104" => "Subreceita __0__ - __1__ está inativa e é utilizada na receita __2__ - __3__ na variação dessa unidade",
		"APP-00105" => "Subreceita __0__ - __1__ está inativa e é utilizada na receita __2__ - __3__ na variação dessa unidade e está em uso no ciclo  __4__ do subgrupo __5__ do serviço __6__ da classe __7__ do menu grid __8__ - __9__ da companhia __10__ na data __11__",
		"APP-00106" => "Subreceita __0__ - __1__ está sem quantidade na receita __2__ - __3__ na variação dessa unidade",
		"APP-00107" => "Subreceita __0__ - __1__ está sem quantidade na receita __2__ - __3__ na variação dessa unidade e está em uso no ciclo  __4__ do subgrupo __5__ do serviço __6__ da classe __7__ do menu grid __8__ - __9__ da companhia __10__ na data __11__",
		"APP-00108" => "Receita __0__ - __1__ não possui composição na variação dessa unidade",
		"APP-00109" => "Receita __0__ - __1__ não possui composição na variação dessa unidade e está em uso no ciclo __2__ do subgrupo __3__ do serviço __4__ da classe __5__ do menu grid __6__ - __7__ da companhia __8__ na data __9__",
		"APP-00110" => "Receita flex __0__ - __1__ possui quantidade de opções a produzir inferior a quantidade de opções indicada na variação dessa unidade",
		"APP-00111" => "Receita flex __0__ - __1__ possui quantidade de opções a produzir inferior	 a quantidade de opções indicada na variação dessa unidade e está em uso no ciclo __2__ do subgrupo __3__ do serviço __4__ da classe __5__ do menu grid __6__ - __7__ da companhia __8__ na data __9__",
		"APP-00112" => "Receita flex __0__ - __1__ possui quantidade de opções a produzir superior a quantidade de opções indicada na variação dessa unidade",
		"APP-00113" => "Receita flex __0__ - __1__ possui quantidade de opções a produzir superior a quantidade de opções indicada na variação dessa unidade e está em uso no ciclo __2__ do subgrupo __3__ do serviço __4__ da classe __5__ do menu grid __6__ - __7__ da companhia __8__ na data __9__",
		"APP-00114" => "Receita __0__ - __1__ não possui padrão de produção cadastrado para a unidade informada e tipo de negócio __2__ e é utilizada no ciclo __3__ do subgrupo __4__ do serviço __5__ da classe __6__ do menu grid __7__ - __8__ da companhia __9__ na data __10__",
		"APP-00115" => "Receita __0__ - __1__ não possui tipo de produção cadastrado para a unidade informada no __2__ do subgrupo __3__ do serviço __4__ da classe __5__ do menu grid __6__ - __7__ da companhia __8__ na data __9__",
		"APP-00116" => "Receita __0__ - __1__ não possui fluxo de produção definido para a unidade informada, setor __2__, categoria __3__, subcategoria __4__, tipo de produção __5__, voo __6__ no ciclo __7__ do subgrupo __8__ do serviço __9__ da classe __10__ do menu grid __11__ - __12__ da companhia __13__ na data __14__",
		"APP-00117" => "A previsão do dia __0__ ainda não foi aprovada",
		"APP-00118" => "Não há menu grid vigente e aprovado para a companhia __0__ na data __1__",
		"APP-00119" => "Há mais de um menu grid vigente e aprovado para a companhia __0__ na data __1__",
		"APP-00120" => "Tipo de negócio não informado para o menu __0__ - __1__ da companhia __2__",
		"APP-00121" => "Não há tabela de preços vigente para a companhia __0__ na data __1__",
		"APP-00122" => "Há mais de uma tabela de preços vigente para a companhia __0__ na data __1__",
		"APP-00123" => "Há mais de um preço para o item de faturamento __0__ da classe __1__ do ciclo __2__ na tabela ativa da companhia __3__ na data __4__",
		"APP-00124" => "Não há preço para o item de faturamento __0__ da classe __1__ do ciclo __2__ na tabela ativa da companhia __3__ na data __4__",
		"APP-00125" => "Loading não foi informado para o subgrupo __0__ do serviço __1__ da classe __2__ do menu grid __3__ - __4__ da companhia __5__ na data __6__",
		"APP-00126" => "Quantidade do loading não foi informada para o subgrupo __0__ do serviço __1__ da classe __2__ do menu grid __3__ - __4__ da companhia __5__ na data __6__",
		"APP-00127" => "Não foi encontrada quantidade na tabela de loading do subgrupo __0__ do serviço __1__ da classe __2__ do menu grid __3__ - __4__ para a quantidade de passageiros __5__ do voo __6__ na data __7__",
		"APP-00128" => "Operação bloqueada. Checklist __0__ não aprovado pela produção.",
		"APP-00129" => "Operação bloqueada. Requisição __0__ do checklist __1__ já foi aprovada.",
		"APP-00130" => "Operação bloqueada. Atendimento __0__ já gerado para a requisição __1__ do checklist __2__.",
		"APP-00131" => "Operação bloqueada. Planejamento __0__ já aprovado.",
		"APP-00132" => "Checklist __0__ está aprovado",
		"APP-00133" => "Checklist __0__ possui requisição de número __1__ relacionada",
		"APP-00134" => "Operação bloqueada. Planejamento __0__ não está aprovado.",
		"APP-00135" => "Receita __0__ - __1__ não possui padrão de produção cadastrado para a unidade informada e tipo de negócio __2__",
		"APP-00136" => "Receita __0__ - __1__ não possui tipo de produção cadastrado para a unidade informada na classe __2__ e companhia __3__",
		"APP-00137" => "Receita __0__ - __1__ não possui fluxo de produção definido para a unidade informada, setor __2__, categoria __3__, subcategoria __4__, tipo de produção __5__ e voo __6__",
		"APP-00138" => "Operação bloqueada. Solicitação __0__ já aprovada.",
		"APP-00139" => "Operação bloqueada. Solicitação __0__ não está aprovada.",
		"APP-00140" => "Operação bloqueada. Requisição __0__ não está aprovada.",
		"APP-00141" => "Operação bloqueada. Atendimento __0__ da requisição __1__ já foi aprovado.", 
		"APP-00142" => "Não há horário de quebra definido para companhia __0__.",
		"APP-00143" => "Não há horário de decolagem definido para o voo __0__.",
		"APP-00144" => "Item de Faturamento __0__ da classe __1__ DO ciclo __2__ do voo __3__ na data __4__ vinculado ao menu __5__ - __6__ que não está aprovado.",
		"APP-00145" => "Item de Faturamento __0__ da classe __1__ DO ciclo __2__ do voo __3__ na data __4__ vinculado ao menu __5__ - __6__ que não está vigente.",
		"APP-00146" => "Item de Faturamento __0__ da classe __1__ DO ciclo __2__ do voo __3__ na data __4__ não está vinculado a subgrupos vigentes.",
		"APP-00147" => "Receita __0__ - __1__ não possui padrão de produção cadastrado para a unidade informada e tipo de negócio __2__.",
		"APP-00148" => "Receita __0__ - __1__ não possui tipo de produção cadastrado para a unidade informada Na classe __2__.",
		"APP-00149" => "Receita __0__ - __1__ não possui fluxo de produção definido para a unidade informada, setor __2__, categoria __3__, subcategoria __4__ e tipo de produção __5__.",
		"APP-00150" => "Percentual do bloco __0__ não parametrizado nos parâmetros de produção da unidade.",
		"APP-00151" => "Item de faturamento __0__ da classe __1__ e ciclo __2__ do voo __3__ está relacionado ao subgrupo __4__ expirado do menu grid __5__ que possui manutenção não relacionada ao item na tabela de preços.",
		"APP-00152" => "Item de faturamento __0__ da classe __1__ e ciclo __2__ do voo __3__ está relacionado ao subgrupo __4__ expirado do menu grid __5__ que possui manutenção não vinculada ao item de faturamento.",
		"APP-00153" => "Equipamento não informado para o voo __0__.",
		"APP-00154" => "Vigência informada para o voo __0__ em conflito com a vigência de __1__ até __2__.",
		"APP-00155" => "Não há produtos para requisição na composição das receitas do checklist __0__.",
		"APP-00156" => "Operação bloqueada. Não há produtos na Requisição __0__.",
		"APP-00157" => "Requisição já gerada para o checklist __0__.",
		"APP-00158" => "Atendimento já gerado para a requisição __0__.",
		"APP-00159" => "Item de faturamento __0__ da classe __1__ e ciclo __2__ do voo __3__ está relacionado ao subgrupo __4__ expirado do menu grid __5__ cuja vigência foi modificada após sua relação no item de faturamento.",
		"APP-00160" => "  A receita é utilizada na composição do Menu Grid: '__0__' da Versão '__3__' pertencente à Companhia '__1__' da Unidade '__2__'.",
		"APP-00161" => "  A subreceita é utilizada na composição da Receita:  '__0__' vinculada com o Menu Grid: '__1__' da Versão '__4__' pertencente à Companhia '__2__' da Unidade '__3__'.",
		"APP-00162" => "  Existe Utilização de Insumos Flex para a Receita na Filial: __0__ e Vigência: __4__ - __5__.",
		"APP-00163" => "  A subreceita é utilizada na composição da Receita: __1__.",
		"APP-00164" => "  A Receita é utilizada na Composição cadastrada para o Subgrupo: __2__.",
		"APP-00165" => "  A Receita possui Padrão de Produção definido na Parametrização da Produção.",
		"APP-00166" => "  A Receita possui Fluxo de Produção definido na Parametrização da Produção para a Filial: '__3__', Setor: '__5__' e Categoria: '__7__'.",
		"APP-00167" => "  A Receita está em processo de Manutenção da Composição do Menu Grid: '__12__' da Filial: '__10__', Companhia: '__11__' no Serviço: '__13__', Classe: '__14__', Subgrupo: '__15__' e Ciclo: '__16__'.",
		"APP-00168" => "  A Receita é utilizada no processo de Substituição da Composição: '__1__' com a Data de Efetivação: '__5__'.",
		"APP-00169" => "  A Receita é utilizada no processo de Substituição da Composição: '__1__' com a Data de Efetivação: '__5__'.",
		"APP-00170" => "  A Receita é utilizada no Checklist: '__2__' com Data de Produção: '__3__'.",
		"APP-00171" => "  A Receita é utilizada na Solicitação de Checklist Emergencial: '__2__' com Data de Produção: '__3__'.",
		"APP-00172" => "Impossível adicionar. Já existe versão em proposta ou em desenvolvimento para este Menu Grid.",
		"APP-00173" => "Quantidade PAX inicial inválida.",
		"APP-00174" => "Impossível realizar a cópia da versão. Já existe versão em desenvolvimento ou proposta para o menu grid de destino.",
		"APP-00175" => "Impossível realizar a operação. A versão de desitino não se encontra em desenvolvimento.",
		"APP-00176" => "Impossível realizar a exclusão. A versão não se encontra em desenvolvimento.",
		"APP-00177" => "Não há tipo de produção cadastrado para a unidade informada no ciclo __0__ do subgrupo __1__ do serviço __2__ da classe __3__ do menu grid __4__ - __5__ da companhia __6__ na data __7__.",
		"APP-00178" => "Não há insumos planejados para o período informado."
	);

    public function __construct ($crudService, $entityManager)
    {
        $this->crudService = $crudService;
        $this->entityManager = $entityManager;
    }

	public function concatErrorMessages($cdfilial, $nrlista, $response, $header = null, $returnToResponse = true, $downloadFileError = false){

		$params = array (
			"CDFILIAL" => $cdfilial,
			"NRLISTA"  => $nrlista
		);
		

		$query = $this->entityManager->getConnection()->prepare(self::SQL_LISTAERROS);
        $query->execute($params);
        $result = $query->fetchAll();
        $erros = array();
        if($header){
        	array_push($erros, $header);
        }

        for ($i = 0; $i < count($result); $i++) {
		    $resultado = $this->convertMessage($result[$i]['DSERRO']);
		    array_push($erros, $resultado);
		};

		$queryDelete = $this->entityManager->getConnection()->prepare(self::SQL_DELETE_LISTAERROS);
        $queryDelete->execute($params);

        $dataSets = $response->getDataSets();
        $listaErros;
        foreach($dataSets as $dataSet) {
        	if($dataSet->getDataSourceName() == 'ListaErros'){
        		$listaErros = $dataSet;
        		break;
        	}
        }
        if(isset($listaErros)) {
        	$oldRows = $listaErros->getRows();
        	$erros = array_merge($erros, $oldRows);
		}
		
		if($downloadFileError){
			//Download file with list error
			$fileName = 'LISTA_ERROS_'.$cdfilial.'_'.$nrlista;
			$fileError = $this->createFile($erros);
			$this->downloadFile($fileName, $fileError);
		} else {
			if($returnToResponse){
				return $response->addDataSet(new DataSet("ListaErros", $erros));
			} else {
				return $erros;
			}
		}
	}
	
	public function getErrorMessages($cdfilial, $nrlista, $response, $header = null, $returnToResponse = true, $downloadFileError = false){

		$params = array (
			"CDFILIAL" => $cdfilial,
			"NRLISTA"  => $nrlista
		);
		

		$query = $this->entityManager->getConnection()->prepare(self::SQL_LISTAERROS);
        $query->execute($params);
        $result = $query->fetchAll();
        $erros = array();
        if($header){
        	array_push($erros, $header);
        }

        for ($i = 0; $i < count($result); $i++) {
		    $resultado = $this->cleanMessage($result[$i]['DSERRO']);
		    array_push($erros, $resultado);
		};

		$queryDelete = $this->entityManager->getConnection()->prepare(self::SQL_DELETE_LISTAERROS);
        $queryDelete->execute($params);

        $dataSets = $response->getDataSets();
        $listaErros;
        foreach($dataSets as $dataSet) {
        	if($dataSet->getDataSourceName() == 'ListaErros'){
        		$listaErros = $dataSet;
        		break;
        	}
        }
        if(isset($listaErros)) {
        	$oldRows = $listaErros->getRows();
        	$erros = array_merge($erros, $oldRows);
		}
		
		if($downloadFileError){
			//Download file with list error
			$fileName = 'LISTA_ERROS_'.$cdfilial.'_'.$nrlista;
			$fileError = $this->createFile($erros);
			$this->downloadFile($fileName, $fileError);
		} else {
			if($returnToResponse){
				return $response->addDataSet(new DataSet("ListaErros", $erros));
			} else {
				return $erros;
			}
		}
	}

	public function convertMessage($message){
		$messageUpper 	= strtoupper($message);
		$codeStart	 	= strpos($messageUpper, "APPERRMSGSTR");
		$codeEnd		= strpos($messageUpper, "APPERRMSGEND");

		if ($codeStart !== FALSE && $codeEnd !== FALSE){
			$msgStart = $codeStart + self::LENGTH_CODE_MSG;
			$msgEnd = $codeEnd - $msgStart;

	        $paramstring = substr($message, $msgStart, $msgEnd);

	        $param = explode("$$", $paramstring);

	        $code = array_shift($param);

	        // $filler = array_fill(sizeof($param), $maxParams-sizeof($param), "");
	        // $param = array_merge($param, $filler);

	        $messageConvert = $this->getMessage($code, $param);
	        $messageConvert = $messageConvert ? $messageConvert : $message;

	        return $messageConvert;
		}
		return $message;
	}
	
	public function cleanMessage($message){
		$messageUpper 	= strtoupper($message);
		$codeStart	 	= strpos($messageUpper, "APPERRMSGSTR");
		$codeEnd		= strpos($messageUpper, "APPERRMSGEND");

		if ($codeStart !== FALSE && $codeEnd !== FALSE){
			$msgStart = $codeStart + self::LENGTH_CODE_MSG;
			$msgEnd = $codeEnd - $msgStart;

	        $paramstring = substr($message, $msgStart, $msgEnd);

	        if($paramstring)
	        	return $paramstring;
		}
		return $message;
	}

	public function getMessage($code, $param) {

		if(\Zeedhi\Framework\Util\Functions::arrayKeyExists($code, self::MESSAGESBYCODE)){
			return $this->replaceValues(self::MESSAGESBYCODE[$code], $param);
		} else {
			//Did not find a message
			return false;
		}
	}

	private function replaceValues($msg, $params) {
		if (is_array($params)) {
			foreach(array_keys($params) as $key){
				$msg = str_replace($this->getKeyName($key), $params[$key], $msg);
			}
		}
		return $msg;
	}

	private function getKeyName($key) {
		return self::SEPARATORKEY.$key.self::SEPARATORKEY;
	}

	public function createFile($erros){
		$erros = is_array($erros) ? $erros : array($erros);
		$file = null;
		$file .= "\t\t  Lista de Erros\r\n";
		foreach ($erros as $msgError) {
			$file .= $msgError."\r\n";
		}
		return $file;
	}

	public function downloadFile($filename, $outFile) {
		$fileContent = "";
		header('Accept-Ranges: none');
		header('Content-Description: File Transfer');
		header('Content-Type: application/octet-stream');
		header('Content-Transfer-Encoding: binary');
		header('Connection: Keep-Alive');
		header('Expires: 0');
		header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
		header('Pragma: public');
		header("Content-Disposition: attachment; filename=".$filename.self::FILE_FORMAT);
		echo $outFile;
		exit;
	}
}