// retirada_pla.spec.js

'use strict';

var helper           = require('../../helper/helper.js'),
    autenticacaoPage = require('../../page-objects/autenticacao.po.js'),
    cardapioPage     = require('../../page-objects/elaboracao_cardapio.po.js'),
    geralPage        = require('../../page-objects/geral.po.js'),
    requisicaoPage   = require('../../page-objects/requisicao_por_servico.po.js'),
    retiradaPage     = require('../../page-objects/retirada_planejamento.po.js'),
    tecfoodPage      = require('../../page-objects/geral_tecfood.po.js');


describe('Teste Tela Retirada - Login', function() {

    it('Efetuar login com dados válidos', function() {
    	browser.get('/mobile');
        autenticacaoPage.login('joana.almeida@teknisa.com', '12');
        expect(autenticacaoPage.telaInicial.getText()).toContain('Início');

    }); 

});


describe('Teste Tela Retirada - Gerar Dados no Cardápio', function() {

    it('Abrir a tela Elaboração do Cardápio', function() {
		
		geralPage.clicaNoMenu();
        geralPage.buscaTela('Elaboração do Cardápio');
        browser.driver.sleep(2000);
        geralPage.abreTela();
        expect(geralPage.telaInicial.getText()).toContain('Seleção do Cardápio');

    });

    it('Filtrar o serviço que será utilizado no cardápio', function() {

        tecfoodPage.clicaServico();
        geralPage.pesquisaNoSearch('REFEICAO JAPONESA');
        browser.driver.sleep(2000);
        geralPage.clicaNoPrimeiroResultado();
        //expect(cardapioPage.buscaServico.getText()).toContain('REFEICAO JAPONESA');		

    });

    it('Verificar se o cardápio é o do mês de Janeiro/2017', function() {

        expect(cardapioPage.dataCardapio.getText()).toContain('Janeiro de 2017');		

    });

    it('Filtrar o cardápio', function() {
		
    	geralPage.clicaEmConfirmar();
    	browser.driver.sleep(5000);
    	expect(geralPage.telaInicial.getText()).toContain('Elaboração do Cardápio');

    });   

    it('Inserir comensais para o dia 01/01/2017', function() {
		
		cardapioPage.abreComensaisDoDia();
        //tecfoodPage.insereComensaisDoDia('50'); //está com erro 
        geralPage.clicaEmSalvar();
        expect(geralPage.msgAlerta.getText()).toEqual('Deseja alterar proporcionalmente o número de porções dos pratos?');    	

    });   

    it('Verificar se os comensais foram salvos', function() {
		
    	geralPage.clicaEmOkAlerta();
        //expect(cardapioPage.comensaisDoDia.getText()).toEqual('50');   //retorna 0 	

    });   

    it('Inserir prato no dia 01/01/2016', function() {
        	
		cardapioPage.clicaTipoDePratoCardapio();
        tecfoodPage.clicaPrato();
        geralPage.pesquisaNoSearch('SOPA CHINESA');
        browser.driver.sleep(2000);
        geralPage.clicaNoPrimeiroResultado();
        geralPage.clicaEmSalvar();
		//expect(cardapioPage.tpPrato.getText()).toContain('50 - SOPA CHINESA'); //não está conseguindo verificar
        
    });

});

/*
describe('Teste Tela Retirada - Requisição', function() {

    it('Abrir a tela Requisição por Serviço', function() {
		
		geralPage.clicaNoMenu();
        geralPage.buscaTela('Requisição por Serviço');
        browser.driver.sleep(2000);
        geralPage.abreTela();
        geralPage.clicaEmCancelar();
        expect(geralPage.telaInicial.getText()).toContain('Requisição por Serviço');

    });	

    it('Filtrar um serviço que utilize retirada por produto', function() {

        geralPage.clicaNoFiltro();
        tecfoodPage.clicaServico();
        geralPage.pesquisaNoSearch('REFEICAO JAPONESA');
        browser.driver.sleep(2000);
        geralPage.clicaNoPrimeiroResultado();
        expect(requisicaoPage.dataRequisicao.getText()).toEqual('01/01/2017');	

    });   
	
    it('Confirmar o filtro', function() {

    	geralPage.clicaEmFiltrar();

    });

    it('Inserir quantidade liberada no primeiro produto listado', function() {

        requisicaoPage.clicaNoPrimeiroProdutoRequisicao();
        requisicaoPage.insereQtdeLiberada('19,0000');
        geralPage.clicaEmSalvar();
        browser.driver.sleep(2000);
        //expect(geralPage.msgNotificacao.getText()).toEqual('Salvo com sucesso.');    	
        //expect(requisicaoPage.qtLiberadaProd1.getText()).toEqual('19');

    });

    it('Inserir quantidade liberada no segundo produto listado', function() {

        requisicaoPage.clicaNoSegundoProdutoRequisicao();
        requisicaoPage.insereQtdeLiberada('16,45');
        geralPage.clicaEmSalvar();
        browser.driver.sleep(2000);
        //expect(geralPage.msgNotificacao.getText()).toEqual('Salvo com sucesso.');
        //expect(requisicaoPage.qtLiberadaProd2.getText()).toEqual('16,45');

    });    

    it('Inserir quantidade liberada no terceiro produto listado', function() {

        requisicaoPage.clicaNoTerceiroProdutoRequisicao();
        requisicaoPage.insereQtdeLiberada('9');
        geralPage.clicaEmSalvar();
        browser.driver.sleep(2000);
        //expect(geralPage.msgNotificacao.getText()).toEqual('Salvo com sucesso.');
        //expect(requisicaoPage.qtLiberadaProd3.getText()).toEqual('9');

    });

    it('Inserir quantidade liberada no quarto produto listado', function() {

        requisicaoPage.clicaNoQuartoProdutoRequisicao();
        requisicaoPage.insereQtdeLiberada('10,1');
        geralPage.clicaEmSalvar();
        browser.driver.sleep(2000);
        //expect(geralPage.msgNotificacao.getText()).toEqual('Salvo com sucesso.');
        //expect(requisicaoPage.qtLiberadaProd4.getText()).toEqual('10,1');

    });

    it('Filtrar um serviço que utilize retirada por tipo de prato', function() {

        geralPage.clicaNoFiltro();
        tecfoodPage.clicaServico();
        geralPage.pesquisaNoSearch('00018');
        browser.driver.sleep(2000);
        geralPage.clicaNoPrimeiroResultado();
        expect(requisicaoPage.dataRequisicao.getText()).toEqual('01/01/2017');	

    });   


    it('Confirmar o filtro', function() {

    	geralPage.clicaEmFiltrar();

    });

	it ('Acessar o primeiro tipo de prato listado', function() {

		requisicaoPage.clicaNoPrimeiroTpPrato();

	});

    it('Inserir quantidade liberada no primeiro produto listado do primeiro tipo de prato', function() {

        requisicaoPage.clicaNoPrimeiroProdutoRequisicaoTipoPrato();
        requisicaoPage.insereQtdeLiberada('19,0000');
        geralPage.clicaEmSalvar();
        browser.driver.sleep(2000);
        //expect(geralPage.msgNotificacao.getText()).toEqual('Salvo com sucesso.');
        //expect(requisicaoPage.qtLiberadaProd1.getText()).toEqual('19');

    });

    it('Inserir quantidade liberada no segundo produto listado do primeiro tipo de prato', function() {

        requisicaoPage.clicaNoSegundoProdutoRequisicaoTipoPrato();
        requisicaoPage.insereQtdeLiberada('16,45');
        geralPage.clicaEmSalvar();
        browser.driver.sleep(2000);
        //expect(geralPage.msgNotificacao.getText()).toEqual('Salvo com sucesso.');
        //expect(requisicaoPage.qtLiberadaProd2.getText()).toEqual('16,45');

    });  

    it('Inserir quantidade liberada no terceiro produto listado do primeiro tipo de prato', function() {

        requisicaoPage.clicaNoTerceiroProdutoRequisicaoTipoPrato();
        requisicaoPage.insereQtdeLiberada('9');
        geralPage.clicaEmSalvar();
        browser.driver.sleep(2000);
        //expect(geralPage.msgNotificacao.getText()).toEqual('Salvo com sucesso.');
        //expect(requisicaoPage.qtLiberadaProd3.getText()).toEqual('9');

    });         


    it('Inserir quantidade liberada no quarto produto listado do primeiro tipo de prato', function() {

        requisicaoPage.clicaNoQuartoProdutoRequisicaoTipoPrato();
        requisicaoPage.insereQtdeLiberada('10,1');
        geralPage.clicaEmSalvar();
        browser.driver.sleep(2000);
        //expect(geralPage.msgNotificacao.getText()).toEqual('Salvo com sucesso.');
        //expect(requisicaoPage.qtLiberadaProd4.getText()).toEqual('10,1');

    });

});


describe('Teste Tela Retirada - Retirada (Planejamento)', function() {


	it('Abrir a tela de Retirada (Planejamento)', function() {

        geralPage.clicaNoMenu();
        geralPage.buscaTela('Retirada (Planejamento)');
        browser.driver.sleep(2000);
        geralPage.abreTela();		

	});

	it('Filtrar um serviço que utilize retirada por produto e que tenha requisição calculada', function() {

       	tecfoodPage.clicaServico();
        geralPage.pesquisaNoSearch('REFEICAO JAPONESA');
        browser.driver.sleep(2000);
        geralPage.clicaNoPrimeiroResultado();		

	});

	it('Verifica a unidade', function() {

        expect(geralPage.buscaUnidade.getText()).toEqual('ADUANA');

	});

	it('verifica a data', function() {

        expect(retiradaPage.dataRetirada.getText()).toEqual('01/12/2016');

	});

	it('Clicar em Filtrar', function() {

    	geralPage.clicaEmFiltrar();
		browser.driver.sleep(2000);
        expect(geralPage.msgAlerta.getText()).toEqual('Não existe retirada para os dados informados. Deseja realizar uma nova retirada?');
        
	});

	it('Confirmar a mensagem de inclusão de nova retirada', function() {

		geralPage.clicaEmOkAlerta();
        geralPage.clicaEmConfirmar();

	});

	it('Atualizar o estoque do itens', function() {

		geralPage.clicaEmAcoes();
        retiradaPage.atualizaEstoque();
        browser.driver.sleep(2000);
        expect(geralPage.msgNotificacao.getText()).toEqual('Estoque atualizado com sucesso!');

	});

	it('Filtrar um serviço que utilize retirada por produto e que não tenha requisição calculada', function() {

       	geralPage.clicaNoFiltro();
       	tecfoodPage.clicaServico();
        geralPage.pesquisaNoSearch('REFEICAO JAPONESA');
        browser.driver.sleep(2000);
        geralPage.clicaNoPrimeiroResultado();		

	});

	it('Filtrar o dia 02/12/2016', function() {

		retiradaPage.clicaDataRetirada();
        geralPage.clicaMesDezembro();
        geralPage.clicaDia02DezembroReti();

	});

	it('Confirmar o filtro', function() {

		geralPage.clicaEmFiltrar();
        expect(geralPage.msgAlerta.getText()).toEqual('Não existe retirada para os dados informados. Deseja realizar uma nova retirada?');

	});

	it('Confirmar a mensagem de inclusão de nova retirada', function() {

		geralPage.clicaEmOkAlerta();
        geralPage.clicaEmConfirmar();

	});

	it('Inserir o primeiro produto manualmente', function() {

        geralPage.clicaNaBuscaProduto();
        geralPage.pesquisaNoSearch('BACALHAU - KG');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();	

	});

	it('Inserir tipo de retirada para o primeiro produto', function() {

        geralPage.clicaTipoRetirada();
        geralPage.pesquisaNoSearch('CONSUMO DE PRODUCAO');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();

	});

	it('Inserir quantidade retirada para o primeiro produto', function() {

		retiradaPage.editarQtdeRetirada('10');

	});

	it('Inserir quantidade devolvida para o primeiro produto', function() {

		retiradaPage.editarQtdeDevolvida('2');

	});	

	it('Salvar a inclusão do primeiro produto', function() {
	
		geralPage.clicaEmSalvar();

	});

	it('Inserir o segundo produto manualmente', function() {

        geralPage.clicaEmAdicionar();
        geralPage.clicaNaBuscaProduto();
        geralPage.pesquisaNoSearch('SALMAO - KG');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();

	});

	it('Inserir tipo de retirada para o segundo produto', function() {

        geralPage.clicaTipoRetirada();
        geralPage.pesquisaNoSearch('02');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();

	});

	it('Inserir quantidade retirada para o segundo produto', function() {

		retiradaPage.editarQtdeRetirada('15');

	});

	it('Inserir quantidade devolvida para o segundo produto', function() {

		retiradaPage.editarQtdeDevolvida('0');

	});	

	it('Salvar a inclusão do segundo produto', function() {
	
		geralPage.clicaEmSalvar();

	});

	it('Atualizar o estoque', function() {

        retiradaPage.atualizaEstoque();
        browser.driver.sleep(1000);
        expect(geralPage.msgNotificacao.getText()).toEqual('Estoque atualizado com sucesso!');

	});

	it('Filtrar um serviço que utilize retirada por tipo de prato e que tenha requisição calculada', function() {

		geralPage.clicaNoFiltro();
        tecfoodPage.clicaServico();
        geralPage.pesquisaNoSearch('00018');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();

	});

	it('Filtrar o dia 01/12/2016', function() {

        retiradaPage.clicaDataRetirada();
        geralPage.clicaMesDezembro();
        geralPage.clicaDia01DezembroReti();

	});

	it('Confirmar o filtro', function() {

       geralPage.clicaEmFiltrar();
       expect(geralPage.msgAlerta.getText()).toEqual('Não existe retirada para os dados informados. Deseja realizar uma nova retirada?');		

	});

	it('Atualizar o estoque', function() {

        geralPage.btnOkAlerta.click();
        geralPage.btnConfirmar.click();
        retiradaPage.atualizaEstoque();
        browser.driver.sleep(2000);
        expect(geralPage.msgNotificacao.getText()).toEqual('Estoque atualizado com sucesso!');

	});

	it('Filtrar um serviço que utilize retirada por tipo de prato e que não tenha requisição calculada', function() {

        tecfoodPage.clicaServico();
        geralPage.pesquisaNoSearch('00018');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();

	});

	it('Filtrar o dia 02/12/2016', function() {

        retiradaPage.clicaDataRetirada();
        geralPage.clicaMesDezembro();
        geralPage.clicaDia02DezembroReti();		

	});

	it('Confirmar o filtro', function() {

        geralPage.clicaEmFiltrar();
        expect(geralPage.msgAlerta.getText()).toEqual('Não existe retirada para os dados informados. Deseja realizar uma nova retirada?');

	});

	it('Confirmar a mensagem', function() {

		geralPage.btnOkAlerta.click();
        geralPage.clicaEmConfirmar();

	});

	it('Incluir produto', function() {

        browser.driver.sleep(1000);
        geralPage.clicaNaBuscaProduto();
        geralPage.pesquisaNoSearch('BACALHAU - KG');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();

	});

	it('Inserir tipo de retirada', function() {

        geralPage.clicaTipoRetirada();
        geralPage.pesquisaNoSearch('CONSUMO DE PRODUCAO');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();
 
	});

	it('Editar quantidade retirada e devolvida', function() {

        retiradaPage.editarQtdeRetirada('10');
        retiradaPage.editarQtdeDevolvida('2');
        geralPage.clicaEmSalvar();

	});

	it('Informar o tipo de prato', function() {

        tecfoodPage.clicaTipoDePrato();
        geralPage.pesquisaNoSearch('PRATO PRINCIPAL');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();

	})

	it('Inserir um segundo produto', function() {

        geralPage.clicaNaBuscaProduto();
        geralPage.pesquisaNoSearch('BACALHAU - KG');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();		

	});

	it('Inserir o tipo de retirada', function() {

        geralPage.clicaTipoRetirada();
        geralPage.pesquisaNoSearch('CONSUMO DE PRODUCAO');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();		

	});

	it('Editar quantidade retirada e devolvida', function() {

        retiradaPage.editarQtdeRetirada('10');
        retiradaPage.editarQtdeDevolvida('2');
        geralPage.clicaEmSalvar();
        expect(geralPage.msgNotificacao.getText()).toEqual('Produto incluído com sucesso!');

	});	

	it('Inserir terceiro produto', function() {

        geralPage.clicaEmAdicionar();
        geralPage.clicaNaBuscaProduto();
        geralPage.pesquisaNoSearch('SALMAO - KG');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();

	});

	it('Inserir o tipo de retirada', function() {

        geralPage.clicaTipoRetirada();
        geralPage.pesquisaNoSearch('02');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();		

	});

	it('Editar quantidade devolvida e retirada', function() {

        retiradaPage.editarQtdeRetirada('15');
        retiradaPage.editarQtdeDevolvida('0');
        geralPage.clicaEmSalvar();
        expect(geralPage.msgNotificacao.getText()).toEqual('Produto incluído com sucesso!');		

	});

    it('Inserir produto sem quantidade suficiente em estoque', function() {

        geralPage.clicaEmAdicionar();
        geralPage.clicaNaBuscaProduto();
        geralPage.pesquisaNoSearch('BACALHAU - KG');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();

    });

    it('Inserir o tipo de retirada', function() {

        geralPage.clicaTipoRetirada();
        geralPage.pesquisaNoSearch('02');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();       

    });

    it('Editar quantidade devolvida e retirada', function() {

        retiradaPage.editarQtdeRetirada('10');
        retiradaPage.editarQtdeDevolvida('2');
        geralPage.clicaEmSalvar();
        expect(geralPage.msgAlerta.getText()).toContain('Quantidade informada não disponível no estoque.'); 

    });

    it('Confirmar alerta', function() {

        geralPage.clicaEmOkAlerta();
        geralPage.clicaEmCancelar();

    });   

    it('Inserir produto sem movimentação em estoque', function() {

        geralPage.clicaEmAdicionar();
        geralPage.clicaNaBuscaProduto();
        geralPage.pesquisaNoSearch('BACALHAU - KG');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();

    });

    it('Inserir o tipo de retirada', function() {

        geralPage.clicaTipoRetirada();
        geralPage.pesquisaNoSearch('02');
        browser.driver.sleep(1000);
        geralPage.clicaNoPrimeiroResultado();       

    });

    it('Editar quantidade devolvida e retirada', function() {

        retiradaPage.editarQtdeRetirada('10');
        retiradaPage.editarQtdeDevolvida('2');
        geralPage.clicaEmSalvar();
        expect(geralPage.msgAlerta.getText()).toEqual('Produto não possui movimentação de estoque.');

    });

    it('Confirmar alerta', function() {

        geralPage.clicaEmOkAlerta();
        geralPage.clicaEmCancelar();

    });   

	it('Atualizar estoque', function() {

        geralPage.selecionaTodosOsRegistros();
        geralPage.clicaEmAcoes();
        retiradaPage.atualizaEstoque();
        browser.driver.sleep(1000);
        expect(geralPage.msgNotificacao.getText()).toEqual('Estoque atualizado com sucesso!');		

	});

    it('Excluir retirada.', function() {

        geralPage.selecionaTodosOsRegistros();
        geralPage.clicaEmExcluir();
        //nao está exibindo pergunta;S
        expect(geralPage.msgNotificacao.getText()).toEqual('Retirada excluída com sucesso');

    });

});*/