'use strict';

function retiradaPlanejamento(){

	var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	var z = new ZeedhiAPIConstructor(browser, protractor);
	var util = require('./util.po.js');

	this.gridId = '2493995912567898485180';//id do grid principal
	this.gridTipoProdutoId = '24939959122776413062891';//id do grid dos produtos por tipo de prato
	this.gridTipoPrato = '2493995917964005972871';// id do grid de tipo de prato
	var self = this;

	this.abrir = function(rotina = 'N'){  
		browser.waitForAngular();
		browser.sleep(2000);
		z.component.menu.open();
		z.component.menu.useSearch('Retirada (Planejamento)');
		z.component.menu.clickByLabel('Retirada (Planejamento)');

        browser.waitForAngular();//espera a pagina carregar completamente
	};

	this.getGridNrRows = function(){
		return z.widget.grid.getNrRows('pla02000_produtos');
	};
	
	/*
	2493995912567898485180 = gridId
	row = id da linha do grid, iniciando por 0, default = 0
	column =  int - id da coluna do grid, iniciando por 0, default = 0
	checkBox = booleano ( True se o grid possui checkbox), default = false
	*/
	this.getGridText = function(row = 0, column = 0, checkBox = false, tipoRetirada = 'P'){
		var locator;
		var IdGrid;

        if(tipoRetirada == 'P'){
        	//IdGrid = '2493995912567898485180';
        	return z.widget.grid.getText(self.gridId, row, column, true);
        }

        else if(tipoRetirada == 'T'){
        	//IdGrid = '24939959122776413062891';
        	locator = self.getRowColumnLocator(self.gridTipoProdutoId, row, column, checkBox);
        	return element(locator).getText();
        }

        else if(tipoRetirada == 'TP'){
        	//IdGrid = '2493995917964005972871';
        	locator = self.getRowColumnLocator(self.gridTipoPrato, row, column, checkBox);
        	return element(locator).getText();
        }
	};
	

	/*Substituição Zeedhi
	O método GetRowCoumnLocator não encontrava o locator das colunas do grid, pois após concatentar o gridId o mesmo verificava
	div.body>.nonbounce>div:nth-child . Este trecho foi alterado para div.body>body>div:nth-child
	*/
	this.clickColumn = function(gridId, row, column, hasCheckbox) {
        var locator = self.getRowColumnLocator(gridId, row, column, hasCheckbox);
        z.util.clickElement(locator);
    };

    this.getRowColumnLocator = function(gridId, row, column, hasCheckbox) {
        hasCheckbox = z.util.validateOptionalParameter(hasCheckbox, false);
        if (hasCheckbox) {
            return by.css('#grid-' + gridId + '> div.body > div > div.tr.cell'+(row + 1)+' > div:nth-child(' + (column + 2) + ') > span');
        } else {
            return by.css('#grid-' + gridId + '> div.body > div > div:nth-child(' + (row + 1) + ')>div:nth-child(' + (column + 1) + ')');
        }
    };
    /* Fim substituição Zeedhi API */

 	/*
	Funcionalidade: Retorna a linha do grid na qual um valor informado (searchText) se encontra
	column: Default = 1 - Coluna na qual o valor será pesquisado
	searchText: texto da busca
	hasCheckBox: Default = false - Se o grid possui ou não checkBox
	*/
	this.getValueRowInGrid = function(column = 1, searchText, hasCheckBox = false){
		return element.all(by.repeater('rowIndex in filtered')).reduce(function(result, elem, index){
			if(result) {
				return result;
			}
			return self.getGridText(index, column, hasCheckBox).then(function(text){
					if(text == searchText){
						return index;
					}
			});
		}).then(function(result){
				if(!result) 
					return -1;
				else
					return result;
			});
	};

	/*
	Funcionalidade: Verifica todas as registros(linhas do grid) em busca de determinado texto em determinada coluna
					A busca é finalizada no momento em que o primeiro registro válido é encontrado.
	column = int - id da coluna a ser utilizada na busca, iniciando por 0, default = 1
	tipoRetirada = 'P'- serviço com retirada por produto; 'T' - Serviço com retirada por tipo de prato; 'TP' - tipo de prato
	*/
	this.gridHasText = function(column = 1, searchText, hasCheckBox = false, tipoRetirada = 'P'){
		var gridId = self.gridId;
		var locator = by.repeater('rowIndex in filtered');
		
		if(tipoRetirada == 'T'){
			//Altera o grid utilizado para o grid de produtos por Tipo de Prato
			gridId = self.gridTipoProdutoId;
			//locator do grid de produtos por Tipo de Prato
			locator = by.css('#grid-'+ gridTipoProdutoId +' > div.body > div > div.tr');
		}

		if(tipoRetirada == 'TP'){
			//Altera o grid utilizado para o grid de Tipo de Prato
			gridId = self.gridTipoPrato;
			locator = by.css('#grid-' + gridTipoPrato + ' > div.body > div > div.tr');
		}

		return element.all(locator).reduce(function(result, elem, index){
				if(result) 
					return result;

				//verifica se existe checkBox, se sim acresce um ao valor informado para o id
				return self.getGridText(index, column, hasCheckBox, tipoRetirada).then(function(text){
					if(text == searchText) {
						return true;
						console.log(searchText);
					}
				});
			}).then(function(result){
				if(!result) {
					return false;
				}

				else{
					return result;
				}
			});
	};

	
	this.selecionarServico = function(nmservico){
		z.field.fieldFunctions.click('NMSERVICO');
		browser.sleep(2000);
		z.util.pressKey(nmservico);//Ao abrir o grid, o cursor deve estar no campo de pesquisa.
		z.application.waitZhLoading();
		z.widget.grid.click('NMSERVICO', nmservico,'0');
	};
	
	this.selecionarDataRetirada = function(dtretirada = 'Today'){
		z.field.fieldFunctions.click('DTRETIRADA');
		
		if(dtretirada == 'Today')
			element(by.css('.day .ng-scope .today')).click();
		else
			z.field.calendar.clickDay(dtretirada);
	};


	/*
	nmcampo = Nome do campo (elemento) que será utilizado para filtrar o calendário
	dia = Dia do calendário a ser selecionado, caso nenhum valor seja informado, o default será o dia atual.
	*/
	this.selecionarDataCalendario = function(nmcampo, dia = 'today'){
		z.field.fieldFunctions.click(nmcampo);

		if(dia != 'today'){
			element.all(by.repeater('day in week')).reduce(function(result, elem, index){
				if(result) return result;

				return elem.getText().then(function(text){
					if(text == dia) return elem;
				});
			}).then(function(result){
				if(!result) 
					throw new Error("Dia não encontrado");
				else
					result.click();
			});
		}
		
		else{
			element(by.css('.day .ng-scope .today')).click();
		}
	};
	

	this.selecionarProduto = function(nmproduto){
		z.field.fieldFunctions.click('NMPRODUTO');
		z.util.pressKey(nmproduto);
		z.widget.grid.click('NMPRODUTO',nmproduto,'0');
	};
	
	this.selecionarTipoRetirada = function(nmtpretirada){
		z.field.fieldFunctions.click('NMTIPORETI');
		z.util.pressKey(nmtpretirada);
		z.widget.grid.click('NMTIPORETI',nmtpretirada,'0');
	};

	this.selecionarNumeroRequisicao = function(nrrequisicao){
		z.field.fieldFunctions.click('NRREQUEXTRRE');
		z.util.pressKey(nrrequisicao);
		z.widget.grid.click('NRREQUEXTRRE', nrrequisicao, '0');
	};
	
	this.selecionarTipoPrato = function(nmtpprato){
		z.field.fieldFunctions.click('NMTIPOPRAT');
		z.util.pressKey(nmtpprato);
		z.widget.grid.click('NMTIPOPRAT', nmtpprato,'0');
	};

	this.selecionarPrato = function(nmprato){
		z.field.fieldFunctions.click('NMPRATO');
		z.util.pressKey(nmprato);
		z.widget.grid.click('NMPRATO', nmprato, '0');
	};

	this.setQtdExtraRetirada = function(qtdextra){
		z.field.fieldFunctions.click('QTEXTRARETI');
		z.field.fieldFunctions.fill('QTEXTRARETI', qtdextra, true);
	};

	this.setQtdConsumida = function(qtdconsumida){
		z.field.fieldFunctions.click('QTRETIRADA');
		z.field.fieldFunctions.fill('QTRETIRADA', qtdconsumida, true);
	};
	
	this.setQtdDevolvida = function(qtddevolvida){
		z.field.fieldFunctions.click('QTDEVOLVRETI');
		z.field.fieldFunctions.fill('QTDEVOLVRETI', qtddevolvida, true);
	};

	this.filtroInicial = function(nmservico,dtretirada = 'Today'){
		var ec = protractor.ExpectedConditions;
		self.selecionarServico(nmservico);
		z.application.waitZhLoading();
		self.selecionarDataRetirada(dtretirada);
		z.component.footer.clickRightActionByLabel('Filtrar');
		
		browser.sleep(3000);	
		
		//Verifica se há retirada para o dia informado, se não realiza a retirada
		element(by.cssContainingText('.zh-text-alert','Não existe retirada para os dados informados.')).isPresent().then(function(present){
			if(present){
				z.component.alert.clickButton("Sim");
				z.component.footer.clickRightActionByLabel('Confirmar');
				z.component.alert.clickMessageOk();
			}
		});
	};

	/*Abre o swipe de um produto
	nmproduto: Nome do produto exibido no grid principal da tela que tera o swipe aberto. 
	Default = 'naoSelecionado', nesta opção,o primeiro produto exibido no grid terá seu swipe aberto.
	tipoRetirada = 'P'- serviço com retirada por produto; 'T' - Serviço com retirada por tipo de prato; 'TP' - tipo de prato

	*/
	this.abrirSwipeProduto = function (nmproduto = 'naoSelecionado', tipoRetirada = 'P'){
		var gridId = self.gridId;
		var locator = by.repeater('rowIndex in filtered');
		
		if(tipoRetirada == 'T'){
			//Altera o grid utilizado para o grid de produtos por Tipo de Prato
			gridId = self.gridTipoProdutoId;
			//locator do grid de produtos por Tipo de Prato
			locator = by.css('#grid-' + gridTipoProdutoId + ' > div.body > div > div.tr');
		}

		if(nmproduto == 'naoSelecionado')
			z.widget.grid.clickColumn(self.gridId, 0, 1, true);
		else
			z.widget.grid.click('NMPRODUTO', nmproduto, gridId, false);
	};

	//Abre o swipe de um Tipo de Prato
	this.abrirSwipeTpPrato = function(nmtpprato = 'naoSelecionado'){
		if(nmtpprato == 'naoSelecionado')
			z.widget.grid.clickColumn(self.gridId, 0, 1, true);
		else
			z.widget.grid.click('NMTIPOPRAT', nmtpprato, gridTipoPrato, false);
	};

	this.limparAlerta = function(){
		var alertas = element.all(by.css('span.notification-message-text.ng-binding')).map(function(elem){
			return elem.click();
		});
	};

	/*
	========================================== CRUD ====================================================
	*/
	this.adicionarProduto = function(nmproduto, nmtpretirada, qtdextra){
		self.selecionarProduto(nmproduto);
		self.selecionarTipoRetirada(nmtpretirada);
		self.setQtdExtraRetirada(qtdextra);
		z.component.footer.clickRightActionByLabel('Salvar');
	};

	this.adicionarProdutoSemEstoque = function(nmproduto, nmtpretirada, qtdextra){
		self.adicionarProduto(nmproduto, nmtpretirada, qtdextra);
		element(by.cssContainingText('.zh-text-alert','Produto não possui movimentação de estoque.')).isPresent().then(function(present){
			if(present){
				z.component.alert.clickMessageOk();
				z.component.footer.clickLeftActionByLabel('Cancelar');
			}
		});
	};

	this.adicionarTipoDePrato = function(tpprato, nmprato, nmproduto, nmtpretirada, qtdextra){
		self.selecionarTipoPrato(tpprato);
		self.selecionarPrato(nmprato);
		self.adicionarProduto(nmproduto, nmtpretirada, qtdextra);
	};

	this.adicionarProdutoTpPrato = function(nmtpprato, nmproduto, nmtpretirada, qtdextra){
		self.abrirSwipeTpPrato(nmtpprato);
		util.adicionar();
		self.adicionarProduto(nmproduto, nmtpretirada, qtdextra);
	};


   	/*
	Funcionalidade: Seleciona um produto no grid e o exclui
	searchText: Texto a ser encontrado no grid para que seja excluído.
	column: Default = 1 . 0 =  busca na coluna  Código . 1 = busca na coluna nome
	tipoRetirada = 'P'- serviço com retirada por produto; 'T' - Serviço com retirada por tipo de prato
	*/
	this.excluirProduto = function(searchText, column = 1, tipoRetirada = 'P'){	
		var gridId = self.gridId;
		var locator = by.repeater('rowIndex in filtered');
		
		if(tipoRetirada == 'T'){
			//Altera o grid utilizado para o grid de Tipo de Prato
			gridId = self.gridTipoProdutoId;
			//locator do grid de produtos por Tipo de Prato
			locator = by.css('#grid-' + gridTipoProdutoId +' > div.body > div > div.tr');
		}

		element.all(locator).map(function(ele, index){
			return self.getGridText(index, column, true, tipoRetirada).then(function(arrayText){
				if(arrayText == searchText){
					return index;
				}
			});
		}).then(function(row){
				row.forEach(function(linha){
					if (typeof linha !== 'undefined') {
						z.widget.grid.clickColumn(gridId, linha, -1, true);
						z.component.footer.clickCenterActionByIcon('trash');
						z.component.alert.clickButton('Sim');
						z.component.alert.clickMessageOk();
					}
				});
			});
	};
	
	/*
	Funcionalidade: Seleciona e exclui todos os produtos do grid
	*/
	this.excluirTodosProdutos = function(nmtpprato){
		z.widget.grid.checkAllRows(self.gridId);
		util.excluir();
	};
	
	/*
	Funcionalidade: Seleciona e exclui todos os produtos do grid por Tipo de Prato
	*/
	this.excluirTodosProdutosTpPrato = function(nmtpprato){
		self.abrirSwipeTpPrato(nmtpprato);
		z.widget.grid.checkAllRows(gridTipoProdutoId);
		util.excluir();
	};


	/*
	Funcionalidade: Seleciona um Tipo de Prato no grid e o exclui
	searchText: Texto a ser encontrado no grid para que seja excluído.
	column: Default = 1 . 0 =  busca na coluna  Código . 1 = busca na coluna nome
	tipoRetirada = 'TP'- Tipo de Prato
	*/
	this.excluirTipoPrato = function(searchText, column = 1, tipoRetirada='TP'){
		var gridId = self.gridTipoPrato;
		var locator = by.css('#grid-' + gridTipoPrato +' > div.body > div > div.tr');
		
		element.all(locator).map(function(ele, index){
			return self.getGridText(index, column, true, tipoRetirada).then(function(arrayText){
				if(arrayText == searchText){
					return index;
				}
			});
		}).then(function(row){
				row.forEach(function(linha){
					if (typeof linha !== 'undefined') {
						z.widget.grid.clickColumn(gridId, linha, -1, true);
						z.component.footer.clickCenterActionByIcon('trash');
						z.component.alert.clickButton('Sim');
						z.component.alert.clickMessageOk();
					}
				});
			});
	};
	
	
	/*
	Funcionalidade: Seleciona um produto no grid e edita o valor de um dos campos
	searchText: Texto a ser encontrado no grid para que seja editado.
	rotinaSwipe: Verifica se a edição é pelo swipe
	*/
	this.editarProduto = function(nmproduto, qtdextra){
		self.abrirSwipeProduto(nmproduto);
		self.setQtdExtraRetirada(qtdextra);
		z.component.footer.clickRightActionByLabel('Salvar');
	};

	this.editarProdutoTpPrato = function(nmtpprato, nmproduto, tipoRetirada = 'T', qtdextra){
		self.abrirSwipeTpPrato(nmtpprato);
		self.abrirSwipeProduto(nmproduto,'T');
		self.setQtdExtraRetirada(qtdextra);
		z.component.footer.clickRightActionByLabel('Salvar');
	};

	this.inserirQtdConsumida = function(nmproduto, qtdconsumida){
		self.abrirSwipeProduto(nmproduto);
		self.setQtdConsumida(qtdconsumida);
		z.component.footer.clickRightActionByLabel('Salvar');
	};
	
	this.inserirQtdSemEstoque = function(nmproduto, qtdconsumida){
		self.inserirQtdConsumida(nmproduto, qtdconsumida);
		element(by.cssContainingText('.zh-text-alert','Quantidade informada não disponível no estoque.')).isPresent().then(function(present){
			if(present){
				z.component.alert.clickMessageOk();
				z.component.footer.clickLeftActionByLabel('Cancelar');
			}
		});
	};

	this.inserirQtdDevolvida = function(nmproduto, qtddevolvida){
		self.abrirSwipeProduto(nmproduto);
		self.setQtdDevolvida(qtddevolvida);
		z.component.footer.clickRightActionByLabel('Salvar');
	};

	this.inserirQtdDevolvidaMaior = function(nmproduto, qtddevolvida){
		self.inserirQtdDevolvida(nmproduto, qtddevolvida);
		element(by.cssContainingText('.zh-text-alert','Quantidade devolvida deve ser menor ou igual a soma das quantidades prevista e extra.')).isPresent().then(function(present){
			if(present){
				z.component.alert.clickMessageOk();
				z.component.footer.clickLeftActionByLabel('Cancelar');
			}
		});
	};

	this.realizarRetiradaSemRequisicao = function(nmservico, dtretirada, nmtpprato, nmprato, nmproduto, nmtpretirada, qtdextra){
		var ec = protractor.ExpectedConditions;

		self.selecionarServico(nmservico);
		browser.sleep(2000);
		self.selecionarDataRetirada(dtretirada);
		z.component.footer.clickRightActionByLabel('Filtrar');
		browser.sleep(3000);	
		z.component.alert.clickButton("Sim");
		z.component.footer.clickRightActionByLabel('Confirmar');
		
		element(by.id('NMTIPOPRAT')).isPresent().then(function(present){
			if(present){
				self.selecionarTipoPrato(nmtpprato);
				self.selecionarPrato(nmprato);	
			}
		});

		self.adicionarProduto(nmproduto, nmtpretirada, qtdextra);
		z.component.alert.clickMessageOk();
		browser.sleep(3000);
	};

	/*
	========================================== AÇÕES ====================================================
	*/
	this.acoesNovaRetirada = function(nmservico, dtretirada){
		z.component.footer.clickRightActionByLabel('Ações');

		//Aciona o label 'Nova Retirada'
		z.util.clickElement(by.css('#popup > span > section > section > section > div > div > ul > li:nth-child(1) > div > div > span'));
		self.selecionarServico(nmservico);
		self.selecionarDataRetirada(dtretirada);
		z.component.footer.clickRightActionByLabel('Confirmar');
		z.component.alert.clickMessageOk();//verificar maneira para quando ja existe retirada para a data
	};
	
	this.acoesExcluirRetirada = function(){
		z.component.footer.clickRightActionByLabel('Ações');

		//Aciona o label Excluir Retirada
		z.util.clickElement(by.css('#popup > span > section > section > section > div > div > ul > li:nth-child(2) > div > div > span'));
		z.component.alert.clickButton('Sim');
		z.component.alert.clickMessageOk();
	};

	this.acoesExibirRomaneio = function(nmservico, dtretiradaini, dtretiradafin, dtcardapioini, dtcardapiofin){
		z.component.footer.clickRightActionByLabel('Ações');

		//Aciona o label Exibir Romaneio
		z.util.clickElement(by.css('#popup > span > section > section > section > div > div > ul > li:nth-child(3) > div > div > span'));

		self.selecionarServico(nmservico);
		self.selecionarDataCalendario('DTRETIRADAINI', dtretiradaini);
		self.selecionarDataCalendario('DTRETIRADAFIN', dtretiradafin);
		self.selecionarDataCalendario('DTCARDAPIOINI', dtcardapioini);
		self.selecionarDataCalendario('DTCARDAPIOFIN', dtcardapiofin);

		z.component.footer.clickRightActionByLabel('Filtrar');
		z.widget.grid.click('NMSERVICO', nmservico, '24939959114454336042751', false);
	};

	this.acoesExibirResumo = function(){
		z.component.footer.clickRightActionByLabel('Ações');

		//Aciona o label Exibir Resumo
		z.util.clickElement(by.css('#popup > span > section > section > section > div > div > ul > li:nth-child(4) > div > div > span'));
		//grid = 24939959133770068892777
	};

	this.acoesAtualizarEstoque = function(column = 1, searchText, qtdextra){
		z.component.footer.clickRightActionByLabel('Ações');

		//Aciona o label Atualizar Estoque
		z.util.clickElement(by.css('#popup > span > section > section > section > div > div > ul > li:nth-child(5) > div > div > span'));

		element(by.cssContainingText('.zh-text-alert','Estoque atualizado com sucesso.')).isPresent().then(function(present){
			if(present){
				z.component.alert.clickMessageOk();
			}
		});

		//Erro - Não esta alterando a quantidade corretamente
		element(by.cssContainingText('.zh-text-alert','A atualização de estoque de alguns produtos faria com que a posição de estoque se tornasse irregular.')).isPresent().then(function(present){
			if(present){
				z.component.alert.clickMessageOk();

				z.widget.grid.click('NMPRODUTO', searchText, '24939959115806196142789', false);
				
				self.setQtdExtraRetirada(qtdextra);
				z.component.footer.clickRightActionByLabel('Salvar');

				z.component.footer.clickLeftActionByLabel('Voltar');
			}
		});
	};
}

module.exports = new retiradaPlanejamento();